@echo off
setlocal enabledelayedexpansion
if not exist temp mkdir temp
if not exist out mkdir out
if not exist raps mkdir raps
if not exist in mkdir in & goto :in
if not exist in\EBOOT.BIN goto :noeboot
tool\scetool.exe -i in\EBOOT.BIN>temp\ebootinfo.txt
for /f "skip=3 tokens=1,*" %%a in (temp\ebootinfo.txt) do if "%%a"=="ContentID" set contentid=%%b
echo %contentid%>temp\contentid.txt
set /p cid=<temp\contentid.txt
for /f "tokens=2 delims=-,_" %%c in (temp\contentid.txt) do set titleid=%%c
for /f "skip=3 tokens=1,*" %%d in (temp\ebootinfo.txt) do if "%%d"=="Licence" set Licence=%%e
for /f "skip=3 tokens=1,*" %%i in (temp\ebootinfo.txt) do if "%%i"=="SELF-Type" set type=%%j
for /f "skip=3 tokens=1,*" %%k in (temp\ebootinfo.txt) do if "%%k"=="App" set app=%%l
if "%app%"=="Type     0x00000000" set apptype=SPRX
if "%app%"=="Type     0x00000001" set apptype=EXEC
if "%app%"=="Type     0x00000020" set apptype=USPRX
if "%app%"=="Type     0x00000021" set apptype=UEXEC
echo make sure that "%cid%.rap" is inside the raps folder.
pause
if not exist raps\%cid%.rap goto :norap
tool\scetool.exe --decrypt in\EBOOT.BIN temp\EBOOT.ELF
if not exist temp\EBOOT.ELF goto :halt
tool\FixELF.exe temp\EBOOT.ELF
tool\scetool.exe --verbose --skip-sections=FALSE --sce-type=SELF --compress-data=TRUE --key-revision=0A --self-app-version=0001000000000000 --self-auth-id=1010000001000003 --self-vendor-id=01000002 --self-ctrl-flags=0000000000000000000000000000000000000000000000000000000000000000 --self-cap-flags=00000000000000000000000000000000000000000000003B0000000100020000 --self-type=NPDRM --self-fw-version=0003005500000000 --np-license-type=FREE --np-app-type=%apptype% --np-content-id=%contentid% --np-real-fname=EBOOT.BIN --encrypt temp\EBOOT.ELF out\EBOOT.BIN
goto :edat
:noeboot
echo you must place the eboot.bin and edats (if any) inside the "in" folder.
echo aborting...
pause
goto :end
:norap
echo %cid%.rap is missing.
echo aborting...
pause
goto :end
:halt
echo %cid%.rap is invalid.
echo aborting...
pause
goto :end
:edat
for %%m in (in\*.edat) do (
tool\klic_bruteforcer.exe %%m tool\dev_klics.txt -line>temp\bruteforce.txt
for /f "tokens=2,4" %%n in (temp\bruteforce.txt) do (
if "%%n"=="Found" set klic=%%o
if "%%n"=="Cannot" cls & echo missing klic for "%%~nm%%~xm", cannot decrypt it. & echo please add the klic to the "dev_klic.txt" file inside the "tool" folder and try again. & pause
)
tool\rap2rifkey raps/%cid%.rap temp/rifkey.dat
tool\sfk hexdump -pure -nofile temp\rifkey.dat>temp\rifkey.txt
set /p rifkey=<temp\rifkey.txt
java -cp tool\core.jar -Xms64m -Xmx1024m DecryptRifkey %%m temp\%%~nm.dat !rifkey! !klic!>temp\decryptresult.txt
java -cp .;tool\core.jar -Xms64m -Xmx1024m EncryptEDAT temp\%%~nm.dat out\%%~nm%%~xm !klic! !cid! 0C 00 03
)
:end
erase /q temp\*
cls
echo all done.
echo the patched files are inside the "out" folder.
pause
exit
:in
echo folders created.
echo place your eboot.bin and edats (if any) inside the "in" folder.
echo place your rap files inside the "raps" folder.
echo after that execute this file again.
pause